/********************************************************************//*********RIGHT EDGE ***********************************************/
/*
**  This file is copyrighted material and is a published work.
**  Copyright 1991 by John Deurbrouck (206)726-3817
**
**  Version History
**  1.0   * First release.
*/

/*
**  Building FFF.EXE
**
**  For Borland C++ and TASM *****************************************
**      Tested with Borland C++ 2.0
**  Debug version:
**      tasm /mx /zi critfail.asm;
**      tasm /mx /zi drv_ab.asm;
**      tasm /mx /zi bytpclus.asm;
**      bcc -w -v -N -ms -f- -d -DDEBUG -edfff fff.c critfail.obj
**          drv_ab.obj bytpclus.obj
**  Production version:
**      tasm /mx critfail.asm;
**      tasm /mx drv_ab.asm;
**      tasm /mx bytpclus.asm;
**      bcc -Z -w -N- -ms -O -G- -f- -d fff.c critfail.obj drv_ab.obj
**          bytpclus.obj
**      lzexe fff
**  For Mix's Power C and MASM ***************************************
**      Tested with PowerC 2.0.2, MASM 5.1
**  Debug version:
**      masm /Mx critfail.asm;
**      mix /_ critfail
**      masm /Mx drv_ab.asm;
**      mix /_ drv_ab
**      masm /Mx bytpclus.asm;
**      mix /_ bytpclus
**      pc /ms /f- /t /s /w fff.c
**      pcl fff critfail drv_ab bytpclus
**      rename fff.exe dfff.exe
**  Production version:
**      masm /Mx critfail.asm;
**      mix /_ critfail
**      masm /Mx drv_ab.asm;
**      mix /_ drv_ab
**      masm /Mx bytpclus.asm;
**      mix /_ bytpclus
**      pc /ms /f- /w fff.c
**      pcl /p- fff critfail drv_ab bytpclus
**      lzexe fff
**  For Microsoft C or QC, with MASM *********************************
**      Tested with MSC 6.0 (cl), QC 2.51 (qcl), and MASM 5.1
**  Debug version:
**      masm /Mx /Zi critfail.asm;
**      masm /Mx /Zi drv_ab.asm;
**      masm /Mx /Zi bytpclus.asm;
**      (q)cl /DDEBUG /Zp1 /W4 /AS /Zi /Fedfff fff.c critfail.obj
**          drv_ab.obj bytpclus.obj
**  Production version:
**      masm /Mx critfail.asm;
**      masm /Mx drv_ab.asm;
**      masm /Mx bytpclus.asm;
**      (q)cl /Zp1 /W4 /AS /Gs fff.c critfail.obj drv_ab.obj
**          bytpclus.obj
**  For Zortech C++ in C mode, with MASM *****************************
**      Tested with ZTC 2.18 and MASM 5.1.  Large model used instead
**      of small, because the critical error handler wouldn't
**      work otherwise.
**  Debug version:
**      ztc -ml -a1 -s -gl -gs -DDEBUG -odfff fff.c critfail.asm
**          drv_ab.asm bytpclus.asm
**  Production version:
**      ztc -ml -a1 fff.c -o critfail.asm drv_ab.asm bytpclus.asm
**
**  For purposes of comparison, here are the sizes of the
**  executables produced by all of the command lines listed above:
**
**  Note that these are all DOS-only executables.  In each case,
**  DFFF.EXE is the debug version of the program, FFF.OLD is the
**  production version, and FFF.EXE is the LZEXE'd version.
**
**********************************************************************
**
**  Directory C:\FFF\BORLAND
**      DFFF.EXE          29945    7-06-91    4:40a     A...
**      FFF.EXE           11285    7-06-91    4:42a     A...
**      FFF.OLD           16128    7-06-91    4:41a     A...
**          3 entries,    57358 bytes       (65536 disk=88%)
**
**  Directory C:\FFF\MIX
**      DFFF.EXE          27728    7-06-91    5:00a     A...
**      FFF.EXE           12630    7-06-91    5:07a     A...
**      FFF.OLD           21680    7-06-91    5:06a     A...
**          3 entries,    62038 bytes       (73728 disk=84%)
**
**  Directory C:\FFF\MSOFT
**      DFFF.EXE          27967    7-06-91    4:37a     A...
**      FFF.EXE           10004    7-06-91    4:39a     A...
**      FFF.OLD           14315    7-06-91    4:38a     A...
**          3 entries,    52286 bytes       (65536 disk=80%)
**
**  Directory C:\FFF\ZORTECH
**      DFFF.EXE          32646    7-06-91    4:35a     A...
**      FFF.EXE           14013    7-06-91    4:36a     A...
**      FFF.OLD           21662    7-06-91    4:35a     A...
**          3 entries,    68321 bytes       (73728 disk=93%)
**  --------------------------------------------------------
**         12 entries,   240003 bytes      (278528 disk=86%)
**********************************************************************
*/

/*
**  First, verify we're being compiled by someone we recognize.
*/
#ifndef __TURBOC__
     #ifndef _MSC_VER
          #ifndef __ZTC__
                #ifndef __POWERC
                    #error This requires Turbo, MSC/QC, Zortech or Mix
                #endif
          #endif
     #endif
#endif

/***
Lint setup
***/
/*lint -esym(714,_stklen) not referenced OK */
/*lint -e720 Boolean test of assignment OK */
/*lint -esym(534,getch,enable_crit_fail,signal) ignore retval is OK */

/***
Includes
***/
#ifdef QUICK_WIN_ACTIVE
     #define _WINDOWS
#endif
#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>
#include<string.h>
#if defined(__TURBOC__)
     #include<mem.h>
     #include<dir.h>
#endif
#include<time.h>
#include<dos.h>
#include<conio.h>
#include<signal.h>
/*lint -e743 negative character constant in limits.h is OK */
#include<limits.h>
/*lint +e743 */
#if defined(_MSC_VER) || defined(__ZTC__) || defined(__POWERC)
     #include<direct.h>
     #include<dos.h>
#endif
#ifdef QUICK_WIN_ACTIVE
     #include<io.h>
     #include<bios.h>
     #include<windows.h>
#endif
#ifndef QUICK_WIN_ACTIVE
     #include"critfail.h"
#endif
#include"drv_ab.h"
#include"bytpclus.h"

/***
Defines
***/
#ifdef DEBUG
     #define EXIT(arg) {trap();myquit(__FILE__,__LINE__,arg);}
#else
     #define EXIT(arg) myquit(arg);
#endif
#define POSSIBLE_DRIVES     26
#define FILES_PER_LINE       5
#define USER_QUIT_KEY       27
#define DIR_ATTRIB (FA_RDONLY|FA_DIREC|FA_ARCH|FA_HIDDEN|FA_SYSTEM)
/*
**  Following macros set the character to display in the case of
**  various attributes being present or absent.
*/
#define YES_ARCHIVE_CHAR   'A'
#define NO_ARCHIVE_CHAR    '.'
#define YES_RDONLY_CHAR    'R'
#define NO_RDONLY_CHAR     '.'
#define YES_HIDDEN_CHAR    'H'
#define NO_HIDDEN_CHAR     '.'
#define YES_SYSTEM_CHAR    'S'
#define NO_SYSTEM_CHAR     '.'

#ifdef _MSC_VER
     #define findfirst(a,b,c)    _dos_findfirst(a,c,b)
     #define findnext            _dos_findnext
     #define ffblk               find_t
     #define MAXDIR              _MAX_PATH
     #define MAXPATH             _MAX_PATH
     #define ff_name             name
     #define ff_ftime            wr_time
     #define ff_fdate            wr_date
     #define ff_attrib           attrib
     #define ff_fsize            size
     #define FA_RDONLY           _A_RDONLY
     #define FA_HIDDEN           _A_HIDDEN
     #define FA_SYSTEM           _A_SYSTEM
     #define FA_LABEL            _A_VOLID
     #define FA_DIREC            _A_SUBDIR
     #define FA_ARCH             _A_ARCH
#endif

#ifdef __ZTC__
     /*
     **  Set up findfirst() for Zortech
     */
     #define findfirst(a,b,c)    _dos_findfirst(a,c,b)
     #define findnext            _dos_findnext
     #define ffblk               FIND
     #define MAXDIR              FILENAME_MAX
     #define MAXPATH             FILENAME_MAX
     #define ff_name             name
     #define ff_ftime            time
     #define ff_fdate            date
     #define ff_attrib           attribute
     #define ff_fsize            size
#endif

/***
Structures and associated Typedefs
***/
typedef struct filespec_queue fs_q;
struct filespec_queue{
     char *filespec;
     fs_q *next;
};
typedef union{
     unsigned int ff_ftime;
     struct time_bit_struct{
          unsigned ft_tsec:5;
          unsigned ft_min:6;
          unsigned ft_hour:5;
     }time_bits;
}dos_time_split;
typedef union{
     unsigned int ff_fdate;
     struct date_bit_struct{
          unsigned fd_day:5;
          unsigned fd_month:4;
          unsigned fd_year:7;
     }date_bits;
}dos_date_split;

/***
Global Variables
***/
#ifdef QUICK_WIN_ACTIVE
#define NEW_ARGV_SIZE 65
char new_cmd_line[NEW_ARGV_SIZE*2+1];
char *new_argv[NEW_ARGV_SIZE];
#endif
fs_q *fs_q_ptr=NULL;                    /* fs_q head */
char search_dir[MAXPATH];               /* search_directory() */
int searching_all=0;                    /* nonzero means /a present */
int fast_search=0;                      /* nonzero for fast search */
int search_attrib=0;                    /* attribute for search */
int attrib_must_have=0;                 /* + desired entry mask
                                                         every bit is required */
int attrib_have_one=0;                  /* one of these bits is
                                                         required if this is
                                                         nonzero */
char *fast_name;                        /* name for fast search */
int drives_to_search[POSSIBLE_DRIVES];  /* nonzero entry here */
                                                     /* means to include in scan */
int show_hidden=0;                      /* 0 means don't show them */
                                                     /* 1 means show them (/h) */
                                                     /* 2 means show them only
                                                         (/ho) */
                                                     /* 3 means show hidden,
                                                         system and read-only ONLY
                                                         (/hro) */
int current_not_root=0;                 /* /s switch */
int verbose=1;                          /* zero=terse listing */
int wide=0;                             /* show in wide format */
int limited=0;                          /* supress entry printing */
int show_dirs=0;                        /* nonzero to look at dirs */
int show_dirs_only=0;                   /* nonzero for dirs only */
int names_shown=0;                      /* entries now on this line */
unsigned long tot_size=0L,dir_size=0L;  /* file contents' size */
unsigned long tot_use=0L,dir_use=0L;    /* clusters used */
unsigned long tot_files=0L,dir_files=0L;/* number of files found */
long bytes_per_cluster;                 /* set in search_drive() */
int user_break=0;                       /* causes ERROR_USER_BREAK */
char *aacCopyrightArray[]={             /* copyright data */
     {""}
};
char *aacUsageArray[]={                 /* usage screen data */
     #ifdef DEBUG
     {"FFF 1.0  ***Debug version***  "
     "Copyright (c) 1991 John Deurbrouck"},
     #else
     {"FFF 1.0  Copyright (c) 1991 John Deurbrouck"},
     #endif
     {"First Published in PC Magazine, October 15, 1991"},
     {"Syntax: FFF [/a] [drive(s)] [/d|do] [/h|ho|hro] [/s]"
     " [/l|t|w] name [name...]"},
     {"       /a ALL. Search drives A:-Z:"},
     {" drive(s) DRIVES. Search each listed drive."},
     {"       /d DIRECTORIES. Find both directories and files."},
     {"      /do DIRECTORIES ONLY. Look for directorie"
     "s, not files."},
     {"       /h HIDDEN. Find entries with hidden and system a"
     "ttributes too."},
     {"      /ho HIDDEN ONLY. Find entries with hidden and system a"
     "ttributes only."},
     {"     /hro HIDDEN READ-ONLY ONLY. Find hidden, system,"
     " read-only entries only."},
     {"       /s SUBDIRECTORIES. Search from current dir (not roo"
      "t) on each drive."},
     {"       /l LIMITED. Show locations of found entries and s"
     "ize summaries only."},
     {"       /t TERSE. Show 1 entry per line in compact format."},
     {"       /w WIDE. List 5 entries per line."},
     #if(FILES_PER_LINE!=5)
          #error Change above 2 lines to match FILES_PER_LINE
     #endif
     {"     name NAME(S) to search for."},
     {""}
};
char *aacErrorArray[]={                 /* error exit strings */
     #ifdef EXITS
          #undef EXITS
     #endif
     #define EXITS(name,string) {string},
     #include"exits.h"
     {""}
};
typedef enum{                           /* create exit_code type */
     #ifdef EXITS
          #undef EXITS
     #endif
     #define EXITS(name,string) name,
                                 /*lint -e537 yes, exits.h included twice OK*/
                                        /*lint -e726 extra comma on enum is OK*/
     #include"exits.h"
     ERROR_ERROR____      /* ANSI doesn't allow comma after last enum*/
                                                                          /*lint +e537*/
}exit_code;                                             /*lint +e726*/
unsigned _stklen=0x2000;          /* set stack size for Turbo C */

/***
Function Prototypes
***/
int main(int argc,char *argv[]);
#ifdef QUICK_WIN_ACTIVE
     int winuser_second_chance(char *progname);
#endif
void show_copyright(void);
void show_usage(void);
#ifdef DEBUG
     void trap(void);
     void myquit(char *file,int line,exit_code arg);
#else
     void myquit(exit_code arg);
#endif
void process_cmd_arg(char *ptr);
int set_drives_to_search(char *ptr);
void add_filespec(char *ptr);
void perform_search(void);
void search_drive(int drive);
void search_directory(void);
int file_should_be_shown(struct ffblk *ptr);
void add_trailing_period(char *ptr);
void strip_trailing_period(char *ptr);
int getmatch(char *expr,char *name);
unsigned long file_disk_usage(long file_size);
void show_sums(unsigned long files,unsigned long size,
unsigned long usage);
char *nice_dir(char *dir);
unsigned long percent(unsigned long top,unsigned long bottom);
void check_user_quit(void);
#ifndef QUICK_WIN_ACTIVE
    #ifndef __ZTC__
        void control_break_handler(void);
    #endif
    #ifdef __ZTC__
        void control_break_handler(int arg);
    #endif
#endif
void setup_fast_search(void);
#if defined(_MSC_VER) || defined(__ZTC__)
int getdisk(void);
#endif
#ifdef __ZTC__
int getcurdir(int drive,char *buffer);
#endif

/***
Function Definitions
***/
int main(int argc,char *argv[]){
/** int main(int argc,char *argv[]);
          calls process_cmd_arg() with each command line argument, then
     calls scan_dirs() and show_results() or show_big_results()
**/
     #ifdef QUICK_WIN_ACTIVE
     static int first_level=1;
     if(first_level)for(;;){
          int winhandle;
          struct _wsizeinfo winsiz;
          _wabout("FFF.EXE 1.0\n\n"
          "Copyright (c) 1991 John Deurbrouck\n\n"
          "First Published in PC Magazine,\nOctober 15, 1991\n");
          if((winhandle=_wgetfocus())==-1)break;
          winsiz._type=_WINSIZEMAX;       /* maxmimize window */
          winsiz._version=_WINVER;
          _wsetsize(winhandle,&winsiz);
          _wsetscreenbuf(winhandle,_WINBUFINF); /* give it memory */
          SetErrorMode(1);                /* Critical error handling */
          _wsetexit(_WINEXITPERSIST);
          show_copyright();
          if(argc==1){
                first_level=0;
                return winuser_second_chance(argv[0]);
          }
          break;
     }
     #else
          enable_crit_fail();
          show_copyright();
          signal(SIGINT,control_break_handler);
     #endif
     argc--;                             /* scan off program name */
     argv++;
     if(!argc)EXIT(ERROR_NO_CMDLINE)
     memset(drives_to_search,0,sizeof(drives_to_search));
     while(argc--){                         /* process cmd line args */
          process_cmd_arg(*argv);
          argv++;
     }
     if(!fs_q_ptr)EXIT(ERROR_NO_FILES)
     {
          /*
          **  Combinations with more than one of /l, /t and /w
          **  don't make sense, do disallow.
          */
          int count=0;
          if(limited)count++;             /* /l */
          if(!verbose)count++;            /* /t */
          if(wide)count++;                /* /w */
          if(count>1)EXIT(ERROR_LTW)
     }
     {
          /*
          **  Combinations of /d and /do don't make sense, disallow.
          */
          if(show_dirs&&show_dirs_only)EXIT(ERROR_D_DO)
     }
/*
     Set up search_attrib, attrib_must_have and attrib_cant_have.
     This determines what files qualify for display.
     The C representation is certainly more compact!
ͻ
                    search_attribattrib_must_haveattrib_have_one
͹
always                FA_RDONLY                                 
                       FA_ARCH                                  
͹
show_hidden                                                     
Ķ
    0                                                           
      (default)                                                 
Ķ
    1                 FA_HIDDEN                                 
      (/h)            FA_SYSTEM                                 
Ķ
    2                 FA_HIDDEN                    FA_HIDDEN    
      (/ho)           FA_SYSTEM                    FA_SYSTEM    
Ķ
    3                 FA_HIDDEN                    FA_HIDDEN    
      (/hro)          FA_SYSTEM                    FA_SYSTEM    
                      FA_RDONLY                    FA_RDONLY    
͹
directory display                                               
Ķ
    show_dirs_only    FA_DIREC      FA_DIREC                    
Ķ
    show_dirs         FA_DIREC                                  
Ķ
    neither                                                     
ͼ
*/
     {
          search_attrib=FA_RDONLY|FA_ARCH;
          if(show_hidden){
                search_attrib|=FA_HIDDEN|FA_SYSTEM;
                if(show_hidden>1){
                     attrib_have_one|=FA_HIDDEN|FA_SYSTEM;
                     if(show_hidden>2){
                          attrib_have_one|=FA_RDONLY;
                     }
                }
          }
          if(show_dirs_only){
                search_attrib|=FA_DIREC;
                attrib_must_have|=FA_DIREC;
          }
          else if(show_dirs)search_attrib|=FA_DIREC;
     }
     setup_fast_search();
     perform_search();
     if(tot_files){
          if(verbose){
                printf("%s-------------------------------------------"
                "-------------\n",
                wide?"-------------------":"");
                show_sums(tot_files,tot_size,tot_use);
          }
     }
     else printf("No entries found\n");
     EXIT(ERROR_SUCCESS)
     return 0;
}
#ifdef QUICK_WIN_ACTIVE
int winuser_second_chance(char *progname){
/** int winuser_second_chance(char *progname);
     Since Windows doesn't provide simple facility for entering
     command line, prompt user for one here.
     Progname is the original argv[0]
**/
     char **argv=new_argv;
     char *ptr=new_cmd_line;
     int new_argc=0;
     printf("Enter command line or <ENTER> for usage information:\n");
     *argv++=progname;
     new_argc++;
     if(new_cmd_line==gets(new_cmd_line)){
          while(*ptr){
                while(isspace((int)*ptr))ptr++;
                if(*ptr){
                     *argv++=ptr;
                     new_argc++;
                     while(*ptr&&!isspace((int)*ptr))ptr++;
                     if(!*ptr)break;
                     *ptr=0;
                     ptr++;
                }
                else break;
          }
     }
     return main(new_argc,new_argv);
}
#endif
void show_copyright(void){
/** void show_copyright(void);
          puts the copyright notice to stderr
**/
     char **t=aacCopyrightArray;
     while(**t)fprintf(stderr,"%s\n",*t++);
}
void show_usage(void){
/** void show_usage(void);
          puts the usage information to stderr
**/
     static int shown=0;
     char **t=aacUsageArray;
     if(shown)return;
     shown=1;
     while(**t)fprintf(stderr,"%s\n",*t++);
}
#ifdef DEBUG
void trap(void){
/** void trap(void);
          Does nothing.  Just here to provide for debugger trapping
     before error goes out of scope.  If you make changes and have
     problems, put a breakpoint on the closing brace of this function.
     When a fatal problem occurs, you can then step out of this
     function back to the scope in which the EXIT() macro occurs.
**/
}
#endif
#ifdef DEBUG
void myquit(char *file,int line,exit_code arg){
#else
void myquit(exit_code arg){
#endif
/** void myquit(exit_code arg);
     DEBUG version has following prototype:
     void myquit(char *file,int line,exit_code arg);
          Shows the appropriate exit string, then bails out with exit()
     to return errorlevel.
          Also displays aacUsageArray if arg==ERROR_USAGE.
**/
     if(names_shown)printf("\n");
     switch(arg){
     case ERROR_USAGE:
     case ERROR_NO_FILES:
     case ERROR_NO_CMDLINE:
     case ERROR_LTW:
     case ERROR_D_DO:
     case ERROR_BAD_SWITCH:
     case ERROR_HELP:
          show_usage();
          break;
     default:
          break;
     }
     #ifdef DEBUG
     fprintf(stderr,"EXITING:%s(%d): %s\n",file,line,
     aacErrorArray[(int)arg]);
     #else
     switch(arg){
     case ERROR_SUCCESS:
     case ERROR_NO_CMDLINE:
     case ERROR_HELP:
          break;
     case ERROR_USER_QUIT:
     case ERROR_USER_BREAK:
     case ERROR_NO_FILES:
          fprintf(stderr,"\nEXITING: %s\n",aacErrorArray[(int)arg]);
          break;
     default:
          fprintf(stderr,"\nERROR: %s\n",aacErrorArray[(int)arg]);
          break;
     }
     #endif
     #ifndef QUICK_WIN_ACTIVE
          disable_crit_fail();
     #endif
     if(arg!=ERROR_SUCCESS)exit((int)arg);
}
void process_cmd_arg(char *ptr){
/** void process_cmd_arg(char *ptr);
     processes each command line parameter
**/
     char *work,*last_colon;
     if(!*ptr)return;
     /*
     **  first we coerce to uppercase
     */
     work=ptr;
     while(*work){
          *work=(char)toupper(*work);
          work++;
     }
     /*
     **  now check for command line arguments
     */
     if(!strcmp(ptr,"/?")||!strcmp(ptr,"/HELP")){
          EXIT(ERROR_HELP)
     }
     if(!strcmp(ptr,"/A")){
          memset(drives_to_search,1,sizeof(drives_to_search));
          searching_all=1;
          return;
     }
     if(!memcmp(ptr,"/D=",3)){
          if(!set_drives_to_search(&ptr[3])){
                printf("Don't recognize \"%s\"\n",ptr);
                EXIT(ERROR_BAD_DRIV)
          }
          return;
     }
     if(!strcmp(ptr,"/D"))   {show_dirs=1;       return; }
     if(!strcmp(ptr,"/DO"))  {show_dirs_only=1;  return; }
     if(!strcmp(ptr,"/HRO")) {show_hidden=3;     return; }
     if(!strcmp(ptr,"/HO"))  {show_hidden=2;     return; }
     if(!strcmp(ptr,"/H"))   {show_hidden=1;     return; }
     if(!strcmp(ptr,"/L"))   {limited=1;         return; }
     if(!strcmp(ptr,"/S"))   {current_not_root=1;return; }
     if(!strcmp(ptr,"/T"))   {verbose=0;         return; }
     if(!strcmp(ptr,"/W"))   {wide=1;            return; }
     if(*ptr=='/'){
          show_usage();
          printf("\nUnknown command-line switch \"%s\"\n",ptr);
          EXIT(ERROR_BAD_SWITCH)
     }
     work=ptr;                  /* separate into drivespec, filespec */
     last_colon=NULL;
     while(*work){
          if(*work==':')last_colon=work;
          work++;
     }
     if(last_colon){
          *last_colon++=0;
          if(!set_drives_to_search(ptr)){
                show_usage();
                printf("\nDon't recognize \"%s\"\n",ptr);
                EXIT(ERROR_BAD_DRIV)
          }
          add_filespec(last_colon);
     }
     else add_filespec(ptr);
}
int set_drives_to_search(char *ptr){
/** int set_drives_to_search(char *ptr);
          Goes through the character string pointed to by ptr.
          Expects a string in the following form:
                ltr_a[-ltr_b]...
          where ltr_a is any letter, and ltr_b is any letter higher
          than ltr_a in the alphabet.  it is expected that all
          letters are uppercase.
          returns 0 for failure
                     1 for success
          primary function is to set drives_to_search entries to nonzero
                for every letter specified
          yes, the letters at each end of the range get set twice, but
                the runtime cost is so tiny it's not worth any code space
                to fix
          note that we allow the user to enter colons, for a string
                that looks like /d=c:-e:g:
          last is set to 120 so if a dash ('-') is encountered before
                any drive letters, we'll fail as we should
**/
     int count,last=120;
     if(!isupper((int)*ptr))return 0;
     for(;;){
          /*
          **  we don't really use the colons, so just discard them
          */
          if(*ptr==':'){
                ptr++;
                continue;
          }
          if(*ptr=='-'){
                if(!(last<ptr[1]&&
                isupper(last)&&isupper((int)ptr[1]))){
                     return 0;
                }
                for(count=last;count<(int)ptr[1];count++){
                     drives_to_search[count-'A']=1;
                }
                ptr++;
                continue;
          }
          last=(int)*ptr;
          if(!last)return 1;
          if(!isupper(last))return 0;
          drives_to_search[last-'A']=1;
          ptr++;
     }
}
void add_filespec(char *ptr){
/** void add_filespec(char *ptr);
     this adds the current filespec to the filespec queue after
     coercing all its letters to uppercase and normalizing all wildcard
     specs. protects against pointer to NULL, but not NULL pointer.
**/
     fs_q *p;
     char *c;
     int star=0,question_marks=0;
     if(!*ptr)return;
     /*
     **  now we ensure that the name passed contains neither
     **  backslashes nor colons.
     */
     c=ptr;
     while(*c){
          if(*c=='\\'||*c==':'){
                show_usage();
                printf("\nImproper name specified: \"%s\"\n",ptr);
                EXIT(ERROR_BAD_NAME)
          }
          c++;
     }
     /*
     **  now get space to keep specification
     */
     if(!(p=malloc(sizeof(fs_q))))EXIT(ERROR_MALLOC)
     p->filespec=ptr;
     p->next=fs_q_ptr;
     fs_q_ptr=p;
     c=ptr;
     while(*c){*c=(char)toupper((int)*c);c++;}
     /*
     **  we now normalize wildcard specs.  We want all arbitrary series
     **  of '?' and '*' characters to end up as the proper number of
     **  '?' chars, followed by a single '*'.  This helps the
     **  expression matcher later.
     */
     for(c=ptr;*ptr;ptr++){
          switch(*ptr){
          case '*':
                star=1;
                break;
          case '?':
                question_marks++;
                break;
          default:
                while(question_marks){
                     *c++='?';
                     question_marks--;
                }
                if(star){
                     *c++='*';
                     star=0;
                }
                *c++=*ptr;
          }
     }
     while(question_marks){
          *c++='?';
          question_marks--;
     }
     if(star)*c++='*';
     *c=0;
}
void perform_search(void){
/** void perform_search(void);
     loops through all drives to be searched.  If no drives are to be
     searched, searches the current drive.  Ensures that if a: or b: is
     specified and there's only one floppy, that the correct one is
     checked.
**/
     int drive,got_one=0;
     if(drives_to_search[0]||drives_to_search[1]){
          if(!drive_ab_present(0)||!drive_ab_present(1)){
                drives_to_search[0]=drives_to_search[1]=1;
          }
     }
     for(drive=0;drive<POSSIBLE_DRIVES;drive++){
          check_user_quit();
          if(drives_to_search[drive]){
                search_drive(drive);
                got_one=1;
          }
     }
     if(!got_one)search_drive(getdisk());
}
void search_drive(int drive){
/** void search_drive(int drive);
     searches specified drive (0=A, 1=B, 2=C, etc.)
     also sets bytes_per_cluster so file_disk_usage() returns
     correct value
**/
     if(drive<2&&!drive_ab_present(drive))return;
     if(!(bytes_per_cluster=get_bytes_per_cluster(drive))){
          if(!searching_all){
                printf("Could not access drive %c:\n\n",drive+'A');
          }
          return;
     }
     sprintf(search_dir,"%c:\\",drive+'A');
     if(current_not_root){
          #if defined(__TURBOC__) || defined(__POWERC)
                if(getcurdir(drive+1,&search_dir[3]))EXIT(ERROR_GETCURDIR)
          #endif
          #if defined(_MSC_VER)
                if(_getdcwd(drive+1,search_dir,MAXDIR)!=search_dir)
                     EXIT(ERROR_GETCURDIR)
          #endif
          #if defined(__ZTC__)
                if(getcurdir(drive+1,search_dir))EXIT(ERROR_GETCURDIR)
          #endif
     }
     search_directory();
}
void search_directory(void){
/** void search_directory(void);
     searches from the directory listed in search_dir[] down
**/
     static int this_is_first_dir=1;     /* to control lead \n */
     struct ffblk b;                     /* findfirst(),findnext() */
     char *end_ptr=search_dir;           /* for append to search dir */
     int showed_dir=0;                   /* tells if dir shown */
     dir_size=dir_use=dir_files=0UL;     /* dir not used yet */
     while(*end_ptr)end_ptr++;           /* point at poststring NULL */
     if(end_ptr[-1]!='\\'){*end_ptr++='\\';*end_ptr=0;} /* ensure \ */
     strcpy(end_ptr,fast_search?fast_name:"*.*");
     check_user_quit();
     if(!findfirst(search_dir,&b,search_attrib)){
          do{
                check_user_quit();
                /*
                **  here we show any results. for every entry found, here
                **  is pseudocode:
                **      if it's "." or ".."
                **          ignore it
                **      else if it's missing an attribute we require
                **          ignore it
                **      else if it has an attribute we don't want
                **          ignore it
                **      else if fast_search or file should be shown
                **          if we're in verbose mode
                **              if directory not yet shown
                **                  show it
                **              endif
                **              show verbose entry
                **          else
                **              show non-verbose entry
                **          endif
                **      endif
                */
                if((b.ff_name[0]!='.')
                /*lint -e621 unusual use of Boolean is intended here */
                &&((b.ff_attrib&attrib_must_have)==attrib_must_have)
                /*lint +e621 */
                &&(!attrib_have_one||(b.ff_attrib&attrib_have_one))
                &&(fast_search||file_should_be_shown(&b))){
                     tot_files++;
                     strip_trailing_period(b.ff_name);
                     if(verbose){
                          dos_time_split t;
                          dos_date_split d;
                          int hour,am_pm;
                          dir_size+=(unsigned long)b.ff_fsize;
                          dir_use+=file_disk_usage(b.ff_fsize);
                          dir_files++;
                          if(!showed_dir){
                                if(names_shown){
                                     printf("\n");
                                     names_shown=0;
                                }
                                showed_dir=1;
                                *end_ptr=0;
                                printf("%sDirectory %s\n",
                                this_is_first_dir?"":"\n",
                                nice_dir(search_dir));
                                this_is_first_dir=0;
                          }
                          if(wide){
                                if(names_shown==FILES_PER_LINE){
                                     printf("\n");
                                     names_shown=0;
                                }
                                if(!limited){
                                     char name_buf[14];
                                     sprintf(name_buf,"%s%c",b.ff_name,
                                     b.ff_attrib&FA_DIREC?'\\':0);
                                     if(!names_shown)printf(" ");
                                     names_shown++;
                                     printf("%-13s%s",name_buf,
                                     names_shown==FILES_PER_LINE?"":"  ");
                                }
                          }
                          else{
                                if(!limited){
                                     char buf[20];
                                     if(b.ff_attrib&FA_DIREC){
                                          strcpy(buf,"<DIR>");
                                     }
                                     else{
                                          sprintf(buf,"%ld",b.ff_fsize);
                                     }
                                     t.ff_ftime=b.ff_ftime;
                                     d.ff_fdate=b.ff_fdate;
                                     hour=t.time_bits.ft_hour;
                                     am_pm=hour<12?'a':'p';
                                     if(hour>12)hour-=12;
                                     if(!hour)hour=12;
                                     printf("    %-12s %10s   %2d-%02d-%02d"
                                     "   %2d:%02d%c     %c%c%c%c\n",
                                     b.ff_name,buf,
                                     (int)d.date_bits.fd_month,
                                     (int)d.date_bits.fd_day,
                                     ((int)d.date_bits.fd_year+80)%100,
                                     hour,(int)t.time_bits.ft_min,am_pm,
                                     b.ff_attrib&FA_ARCH?
                                     YES_ARCHIVE_CHAR:NO_ARCHIVE_CHAR,
                                     b.ff_attrib&FA_RDONLY?
                                     YES_RDONLY_CHAR:NO_RDONLY_CHAR,
                                     b.ff_attrib&FA_HIDDEN?
                                     YES_HIDDEN_CHAR:NO_HIDDEN_CHAR,
                                     b.ff_attrib&FA_SYSTEM?
                                     YES_SYSTEM_CHAR:NO_SYSTEM_CHAR);
                                }
                          }
                     }
                     else{                   /* not verbose */
                          strcpy(end_ptr,b.ff_name);
                          printf("%s%s\n",search_dir,
                          b.ff_attrib&FA_DIREC?"\\":"");
                     }
                }
          }while(!findnext(&b));
          if(verbose&&dir_files){
                show_sums(dir_files,dir_size,dir_use);
                tot_size+=dir_size;
                tot_use+=dir_use;
          }
     }
     strcpy(end_ptr,"*.*");
     if(!findfirst(search_dir,&b,DIR_ATTRIB)){ /* process subdirs */
          do{
                if((b.ff_name[0]!='.')
                &&(b.ff_attrib&FA_DIREC)){
                     strcpy(end_ptr,b.ff_name);
                     search_directory();
                }
          }while(!findnext(&b));
     }
}
int file_should_be_shown(struct ffblk *ptr){
/** int file_should_be_shown(struct ffblk *ptr);
     returns 0 if file should not be shown
                1 if file should be shown
**/
     fs_q *p=fs_q_ptr;
     add_trailing_period(ptr->ff_name);
     while(p){
          if(getmatch(p->filespec,ptr->ff_name))return 1;
          p=p->next;
     }
     return 0;
}
void add_trailing_period(char *ptr){
/** void add_trailing_period(char *ptr);
     adds a period to the end of the character string IF it doesn't
     already contain a period.
**/
     while(*ptr){
          if(*ptr=='.')return;
          ptr++;
     }
     *ptr++='.';
     *ptr=0;
}
void strip_trailing_period(char *ptr){
/** void strip_trailing_period(char *ptr);
     if the last character of the given string is a period, gets rid of
     the period.
**/
     while(*ptr)ptr++;
     if(ptr[-1]=='.')ptr[-1]=0;
}
int getmatch(char *expr,char *name){
/** int getmatch(char *expr,char *name);
     this function tries to match expr against name.
     returns 1 for yes, they match
                0 for no, they don't match
     this function recursively processes '*' characters in expr
**/
     int max_usable;
     for(;;){
          if(!*expr&&!*name)return 1;
          if(!*expr){
                if(*name=='.'&&!name[1])return 1;
                return 0;
          }
          if(!*name){
                if(*expr=='*'&&!expr[1])return 1;
                return 0;
          }
          switch(*expr){
          case '*':
                expr++;
                max_usable=(int)strlen(name)+1;
                do{
                     max_usable--;
                     if(getmatch(expr,&name[max_usable]))return 1;
                }while(max_usable);
                return 0;
          case '?':
                if(!*name)return 0;
                expr++;
                name++;
                break;
          default:
                if(*expr!=*name)return 0;
                expr++;
                name++;
          }
     }
}
unsigned long file_disk_usage(long file_size){
/** unsigned long file_disk_usage(long file_size);
     given a size in bytes of a given file, returns the number of bytes
     used on the disk to store that file (uses bytes_per_cluster).
**/
     long clusters,remainder;
     clusters=file_size/bytes_per_cluster;
     remainder=file_size%bytes_per_cluster;
     if(remainder)clusters++;
     return (unsigned long)(clusters*bytes_per_cluster);
}
void show_sums(unsigned long files,unsigned long size,
unsigned long usage){
/** void show_sums(unsigned long files,unsigned long size,
     unsigned long usage);
**/
     char buf[40],*p;
     size_t length;
     if(names_shown){
          names_shown=0;
          printf("\n");
     }
     printf("%s%9lu entr",wide?"                   ":"",files);
     if(show_dirs_only){
          printf("%s\n",files==1UL?"y":"ies");
          return;
     }
     printf("%s%9lu"" byte%s",
     files==1UL?"y,  ":"ies,",size,size==1UL?" ":"s");
     if(!size){
          printf("\n");
          return;
     }
     sprintf(buf,"         %13lu disk=%lu%%",
     usage,percent(size,usage));
     p=buf;
     while(*p==' ')p++;
     p[-1]='(';
     length=strlen(buf);
     p=buf;
     while(length>22){
          length--;
          p++;
     }
     printf("%s)\n",p);
}
char *nice_dir(char *dir){
/** char *nice_dir(char *dir);
     copies *dir into a static buffer, strips off the trailing
     backslash if any (and the string is longer than 3 characters),
     and returns a pointer to the static buffer. This is so you get
     the better looking
          Directory C:\DOS\UTILS
     instead of
          Directory C:\DOS\UTILS\
**/
     static char buffer[MAXPATH+1];
     char *p;
     size_t length=strlen(dir);
     if(length>MAXPATH)return dir;
     if(length<4)return dir;
     strcpy(buffer,dir);
     p=buffer;
     while(*p)p++;
     if(p[-1]=='\\')p[-1]=0;
     return buffer;
}
unsigned long percent(unsigned long top,unsigned long bottom){
/** unsigned long percent(unsigned long top,unsigned long bottom);
     returns a percent, top of bottom. example:
          percent(100UL,1000UL)==10UL
     Handles cases where top * 1000UL overflows long.
     This is a bit awkward, but allows us to have no floating point at
     all in our code.
     Returns 100UL if top exactly equals bottom, and 0UL if top is 0UL.
     Otherwise, rounds to nearest value and coerces to the range
     1UL-99UL.
**/
     unsigned long work;
     if(top==bottom)return 100UL;
     if(!top)return 0UL;
     if(bottom>(ULONG_MAX/1000UL)){
          top/=1000UL;
          bottom/=1000UL;
     }
     work=((top*1000UL)/bottom+5UL)/10UL;
     if(work>99UL)work=99UL;
     if(work<1UL)work=1UL;
     return work;
}
void check_user_quit(void){
/** void check_user_quit(void);
     checks to see if the user pressed the quit key. if so, bails out.
**/
     int inkey;
     if(user_break)EXIT(ERROR_USER_BREAK)
     #ifdef QUICK_WIN_ACTIVE
     _wyield();
     #else
     while(kbhit()){
          if(!(inkey=getch())){
                if(kbhit()){
                     getch();
                     continue;
                }
          }
          if(inkey==USER_QUIT_KEY)EXIT(ERROR_USER_QUIT)
     }
     #endif
}
#ifndef QUICK_WIN_ACTIVE
#ifdef __ZTC__
void control_break_handler(int arg){
#else
void control_break_handler(void){
#endif
/** void control_break_handler(void);
     handles control-break by setting user_break, which is then used by
     check_user_quit()
**/
     user_break=1;
     signal(SIGINT,control_break_handler);
}
#endif
void setup_fast_search(void){
/** void setup_fast_search(void);
     The extended wildcards are significantly slower than allowing
     DOS to report matches only.  In the case where it's possible,
     this function sets things so that the faster search can
     be performed.
**/
     char *ptr;
     static char local_name_storage[20];
     if(!fs_q_ptr)return;                /* no filespec */
     if(fs_q_ptr->next)return;           /* >1 filespecs */
     ptr=fs_q_ptr->filespec;
     if(!strcmp(ptr,"*")){
          fs_q_ptr->filespec="*.*";
          fast_search=1;
     }
     else if(!strcmp(ptr,"*.")){
          fast_search=1;
     }
     else{
          int last_was_star=0;
          while(*ptr){
                if(*ptr=='?'&&(ptr[1]=='*'||ptr[1]=='.'||!ptr[1]))return;
                if(last_was_star&&(*ptr!='.'))return;
                last_was_star=*ptr=='*'?1:0;
                ptr++;
          }
          fast_search=1;
     }
     if(fast_search){
          int got_period=0;
          char *p=fs_q_ptr->filespec;
          while(*p){
                if(*p=='.'){
                     got_period=1;
                     break;
                }
                p++;
          }
          if((!got_period)&&(p[-1]=='*')){
                fast_name=local_name_storage;
                strcpy(fast_name,fs_q_ptr->filespec);
                strcat(fast_name,".*");
          }
          else fast_name=fs_q_ptr->filespec;
     }
}
#if defined(_MSC_VER)
int getdisk(void){
/** int getdisk(void);
     Written to make a lookalike for Borland's getdisk()
     On return, 0 is drive A, 1 is B, etc.
**/
     return(_getdrive()-1);
}
#endif
#if defined(__ZTC__)
int getdisk(void){
/** int getdisk(void);
     Written to make a lookalike for Borland's getdisk()
**/
     int retval;
     dos_getdrive((unsigned int *)&retval);
     return(retval-1);
}
#endif
#ifdef __ZTC__
int getcurdir(int drive,char *buffer){
/** int getcurdir(int drive,char *buffer);
     Provides functionality of Borland's getcurdir() for Zortech.
     A return of 0 means success.
     For drive parm, A=1, B=2, etc.
**/
     unsigned int old_drive,nbr_drives,new_drive;
     char *getcwd_retval=NULL;
     dos_getdrive(&old_drive);           /* save current drive */
     dos_setdrive((unsigned int)drive,&nbr_drives);
     dos_getdrive(&new_drive);           /* verify change worked */
     if((int)new_drive==drive){          /* success */
          getcwd_retval=getcwd(buffer,FILENAME_MAX);
     }
     if(new_drive!=old_drive)dos_setdrive(old_drive,&nbr_drives);
     return (getcwd_retval==buffer)?0:1;
}
#endif
#ifdef QUICK_WIN_ACTIVE
int far drive_ab_present(int drive){
/** int far drive_ab_present(int drive);
     'drive' should be zero to check drive A, nonzero for B
     Returns 1 if the specified drive is present, 0 otherwise
**/
     unsigned magic_floppy_byte,equip=_bios_equiplist();
     unsigned char _far *p;
     /*
     **  if BIOS says no floppies, return success
     */
     if(!(equip&1))return 1;
     /*
     **  set equip equal to number of floppies in system
     **  we always return 1 if (floppies != 1)
     */
     equip>>=6;
     equip&=3;
     equip++;
     if(equip!=1)return 1;
     /*
     **  set drive to 1 if nonzero
     */
     if(drive)drive=1;
     /*
     **  get magic floppy byte
     */
     FP_SEG(p)=0x40;
     FP_OFF(p)=0x104;
     magic_floppy_byte=(unsigned)*p;
     if(magic_floppy_byte)magic_floppy_byte=1;
     /*
     **  Logic table...              drive (drive desired)
     **                                0 (A)       1 (B)
     **
     ** magic_floppy_byte  0 (A)       1           0
     **   (actual drive)   1 (B)       0           1
     */
     return (int)magic_floppy_byte==drive?1:0;
}
long far get_bytes_per_cluster(int drive){
/** long far get_bytes_per_cluster(int drive);
     Provided because the .ASM version does not work for Windows.
     drive==0 means drive A:.
**/
     struct diskfree_t df;
     if(_dos_getdiskfree(drive+1,&df))return 1L;
     return (long)df.bytes_per_sector * (long)df.sectors_per_cluster;
}
#endif
